//---------------------------------------------------------------------------
#include <vcl.h>
#include <printers.hpp>
#pragma hdrstop

#include "f_dm.h"
#include "f_form_main.h" 
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tdm *dm;
//---------------------------------------------------------------------------
__fastcall Tdm::Tdm(TComponent* Owner)
    : TDataModule(Owner)
{
        nn_cat_init();
        NN_cat_init();
        K_cat_init();
        OP_cat_init();
        V_cat_init();
        SV_cat_init();
        SN_cat_init();
        T_cat_init();
        VOUPO_init();

        s_test_pass = false;
        kot_pass = false;
        vpp_pass = false;
        prog_pass = false;

}
//---------------------------------------------------------------------------
void __fastcall Tdm::f_calc_stan()
{
     // calculate all stans and other stuff
     // after - printing on default printer
     int a = this->s_test_points; int b;

     if( a <= 25) b = 1;
     if( a >= 26 && a <=33) b =2;
     if( a >= 34 && a <= 42) b =3;
     if( a >= 43 && a <= 51) b =4;
     if( a >= 52 && a <= 60) b =5;
     if( a >= 61 && a <= 71) b =6;
     if( a >= 72 && a <= 80) b =7;
     if( a >= 81 && a <= 92) b =8;
     if( a >= 93 && a <= 106) b =9;
     if( a >= 109) b =10;
     this->s_test_stan = b;

     a = this->kot_points;
     if( a <= 5) b = 1;
     if( a >= 6 && a <=7) b =2;
     if( a >= 8 && a <= 9) b =3;
     if( a >= 10 && a <= 11) b =4;
     if( a >= 12 && a <= 13) b =5;
     if( a >= 14 && a <= 16) b =6;
     if( a >= 17 && a <= 19) b =7;
     if( a >= 20 && a <= 22) b =8;
     if( a >= 23 && a <= 25) b =9;
     if( a >= 26) b =10;
     this->kot_stan = b;

     a = this->kot_stan + s_test_stan;
     if( a >= 2 && a <= 4) b = 1;
     else
     if( a >= 5 && a <= 6) b = 2;
     else
     if( a == 7) b = 3;
     else
     if( a >= 8 && a <= 9) b = 4;
     else
     if( a >= 10 && a <= 11) b = 5;
     else
     if( a >= 12 && a <= 13) b = 6;
     else
     if( a >= 14 && a <= 15) b = 7;
     else
     if( a == 16) b = 8;
     else
     if( a >= 17 && a <= 18) b =9;
     else
     if( a >= 19 && a <= 20) b =10;
     this->OPS_stan = b;  this->OPS_points = a;

     a = this->NPU_points;
     if( a >= 131 ) b = 1;
     if( a >= 104 && a <= 130) b = 2;
     if( a >= 88 && a <= 103) b = 3;
     if( a >= 68 && a <= 87) b = 4;
     if( a >= 49 && a <= 67) b = 5;
     if( a >= 35 && a <= 48) b = 6;
     if( a >= 26 && a <= 34) b = 7;
     if( a >= 19 && a <= 25) b = 8;
     if( a >= 12 && a <= 18) b = 9;
     if( a <= 11) b = 10;
     this->NPU_stan = b;

     a = this->N_points;
     if( a <= 20) b = 1;
     if( a >= 21 && a <= 28) b = 2;
     if( a >= 29 && a <= 37) b = 3;
     if( a >= 38 && a <= 45) b = 4;
     if( a >= 46 && a <= 53) b = 5;
     if( a >= 54 && a <= 61) b = 6;
     if( a >= 62 && a <= 68) b = 7;
     if( a >= 69 && a <= 73) b = 8;
     if( a >= 74 && a <= 76) b = 9;
     if( a >= 77) b =10;
     this->N_stan = b;

     a = this->K_points;
     if( a <= 17) b = 1;
     if( a >= 18 && a <= 23) b = 2;
     if( a >= 24 && a <= 29) b = 3;
     if( a >= 30 && a <= 34) b = 4;
     if( a >= 35 && a <= 39) b = 5;
     if( a >= 40 && a <= 44) b = 6;
     if( a >= 45 && a <= 49) b = 7;
     if( a >= 50 && a <= 53) b = 8;
     if( a >= 54 && a <= 55) b = 9;
     if( a >= 56) b =10;
     this->K_stan = b;

     a = this->OP_points;
     if( a <= 15) b = 1;
     if( a >= 16 && a <= 18) b = 2;
     if( a >= 19 && a <= 21) b = 3;
     if( a >= 22 && a <= 24) b = 4;
     if( a >= 25 && a <= 28) b = 5;
     if( a >= 29 && a <= 32) b = 6;
     if( a >= 33 && a <= 35) b = 7;
     if( a >= 36 && a <= 37) b = 8;
     if( a >= 38 && a <= 39) b = 9;
     if( a >= 40) b =10;
     this->OP_stan = b;

     a = this->SV_points;
     if( a <= 10) b = 1;
     if( a >= 11 && a <= 15) b = 2;
     if( a >= 16 && a <= 18) b = 3;
     if( a >= 19 && a <= 21) b = 4;
     if( a >= 22 && a <= 24) b = 5;
     if( a >= 25 && a <= 28) b = 6;
     if( a >= 29 && a <= 31) b = 7;
     if( a >= 32 && a <= 34) b = 8;
     if( a >= 35 && a <= 36) b = 9;
     if( a >= 37) b =10;
     this->SV_stan = b;

     a = this->V_points;
     if( a <= 5) b = 1;
     if( a >= 6 && a <= 11) b = 2;
     if( a >= 12 && a <= 17) b = 3;
     if( a >= 18 && a <= 23) b = 4;
     if( a >= 24 && a <= 28) b = 5;
     if( a >= 29 && a <= 33) b = 6;
     if( a >= 34 && a <= 36) b = 7;
     if( a >= 37 && a <= 39) b = 8;
     if( a == 40) b = 9;
     if( a >= 41) b =10;
     this->V_stan = b;

     a = this->SN_points;
     if( a <= 11) b = 1;
     if( a >= 12 && a <= 15) b = 2;
     if( a >= 16 && a <= 18) b = 3;
     if( a >= 19 && a <= 21) b = 4;
     if( a >= 22 && a <= 25) b = 5;
     if( a >= 26 && a <= 28) b = 6;
     if( a >= 29 && a <= 32) b = 7;
     if( a >= 33 && a <= 35) b = 8;
     if( a >= 36 && a <= 37) b = 9;
     if( a >= 38) b =10;
     this->SN_stan = b;

     a = this->T_points;
     if( a <= 13) b = 1;
     if( a >= 14 && a <= 19) b = 2;
     if( a >= 20 && a <= 27) b = 3;
     if( a >= 28 && a <= 33) b = 4;
     if( a >= 34 && a <= 39) b = 5;
     if( a >= 40 && a <= 45) b = 6;
     if( a >= 46 && a <= 51) b = 7;
     if( a >= 52 && a <= 55) b = 8;
     if( a >= 56 && a <= 58) b = 9;
     if( a >= 59) b =10;
     this->T_stan = b;

    //calculating categoties
    this->nn_cat_points = this->nn_cat[this->NPU_stan-1][this->OPS_stan-1];
    this->NN_cat_points = this->NN_cat[this->N_stan-1][this->nn_cat_points-1];
    this->K_cat_points = this->K_cat[this->NN_cat_points-1][K_stan-1];
    this->OP_cat_points = this->OP_cat[this->NN_cat_points-1][OP_stan-1];
    this->V_cat_points = this->V_cat[this->NN_cat_points-1][V_stan-1];
    this->SV_cat_points = this->SV_cat[this->NN_cat_points-1][SV_stan-1];
    this->SN_cat_points = this->SN_cat[this->NN_cat_points-1][SN_stan-1];
    this->T_cat_points = this->T_cat[this->NN_cat_points-1][T_stan-1];
    this->VOUPO_points = this->VOUPO[this->N_stan-1][this->nn_cat_points-1];
}

void Tdm::nn_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 1, 1, 1, 1, 1, 2, 2, 2, 2,  2};
int a2[] =  { 1, 2, 2, 2, 2, 2, 2, 2, 2,  2};
int a3[] =  { 1, 2, 2, 3, 3, 3, 3, 4, 5,  6};
int a4[] =  { 1, 3, 3, 3, 3, 4, 5, 6, 7,  8};
int a5[] =  { 1, 3, 4, 4, 4, 5, 6, 7, 8,  9};
int a6[] =  { 1, 3, 4, 5, 5, 5, 7, 8, 9, 10};
int a7[] =  { 2, 3, 4, 5, 6, 6, 7, 8, 9, 10};
int a8[] =  { 2, 3, 5, 6, 6, 7, 7, 8, 9, 10};
int a9[] =  { 2, 3, 5, 6, 6, 7, 8, 9,10, 10};
int a10[] = { 2, 3, 5, 6, 7, 8, 9,10,10, 10};

       for(int i = 0; i < 10; i++)
       {
           this->nn_cat[0][i] = a1[i];
           this->nn_cat[1][i] = a2[i];
           this->nn_cat[2][i] = a3[i];
           this->nn_cat[3][i] = a4[i];
           this->nn_cat[4][i] = a5[i];
           this->nn_cat[5][i] = a6[i];
           this->nn_cat[6][i] = a7[i];
           this->nn_cat[7][i] = a8[i];
           this->nn_cat[8][i] = a9[i];
           this->nn_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::NN_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 1, 1, 1, 1, 2, 2, 2, 3, 3,  3};
int a2[] =  { 1, 1, 2, 2, 3, 3, 4, 5, 5,  5};
int a3[] =  { 1, 2, 2, 3, 3, 4, 5, 6, 7,  8};
int a4[] =  { 1, 2, 3, 4, 4, 5, 6, 7, 8,  9};
int a5[] =  { 1, 2, 4, 4, 5, 6, 7, 8, 9, 10};
int a6[] =  { 1, 2, 4, 5, 6, 7, 7, 8, 9, 10};
int a7[] =  { 1, 2, 4, 5, 6, 7, 8, 8, 9, 10};
int a8[] =  { 2, 2, 4, 5, 6, 7, 8, 8, 9, 10};
int a9[] =  { 2, 2, 4, 5, 6, 7, 8, 8, 9, 10};
int a10[] = { 2, 2, 4, 5, 6, 7, 8, 9, 9, 10};

       for(int i = 0; i < 10; i++)
       {
           this->NN_cat[0][i] = a1[i];
           this->NN_cat[1][i] = a2[i];
           this->NN_cat[2][i] = a3[i];
           this->NN_cat[3][i] = a4[i];
           this->NN_cat[4][i] = a5[i];
           this->NN_cat[5][i] = a6[i];
           this->NN_cat[6][i] = a7[i];
           this->NN_cat[7][i] = a8[i];
           this->NN_cat[8][i] = a9[i];
           this->NN_cat[9][i] = a10[i];

       }

}

//---------------------------------------------------------------------------
void Tdm::K_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a3[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 3};
int a4[] =  { 4, 4, 4, 4, 3, 3, 3, 3, 3, 3};
int a5[] =  { 4, 3, 3, 3, 3, 3, 3, 3, 3, 3};
int a6[] =  { 4, 3, 3, 3, 2, 2, 2, 2, 2, 2};
int a7[] =  { 4, 3, 3, 3, 2, 2, 2, 1, 1, 1};
int a8[] =  { 4, 3, 2, 2, 1, 1, 1, 1, 1, 1};
int a9[] =  { 4, 3, 2, 1, 1, 1, 1, 1, 1, 1};
int a10[] = { 4, 3, 2, 1, 1, 1, 1, 1, 1, 1};

       for(int i = 0; i < 10; i++)
       {
           this->K_cat[0][i] = a1[i];
           this->K_cat[1][i] = a2[i];
           this->K_cat[2][i] = a3[i];
           this->K_cat[3][i] = a4[i];
           this->K_cat[4][i] = a5[i];
           this->K_cat[5][i] = a6[i];
           this->K_cat[6][i] = a7[i];
           this->K_cat[7][i] = a8[i];
           this->K_cat[8][i] = a9[i];
           this->K_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::OP_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a3[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 3, 3};
int a4[] =  { 4, 4, 4, 4, 3, 3, 3, 3, 3, 3};
int a5[] =  { 4, 3, 3, 3, 3, 3, 3, 3, 3, 2};
int a6[] =  { 4, 3, 3, 2, 2, 2, 2, 2, 2, 2};
int a7[] =  { 4, 3, 2, 2, 2, 2, 2, 2, 2, 1};
int a8[] =  { 3, 3, 2, 1, 1, 1, 1, 1, 1, 1};
int a9[] =  { 3, 3, 2, 1, 1, 1, 1, 1, 1, 1};
int a10[] = { 3, 2, 2, 1, 1, 1, 1, 1, 1, 1};

       for(int i = 0; i < 10; i++)
       {
           this->OP_cat[0][i] = a1[i];
           this->OP_cat[1][i] = a2[i];
           this->OP_cat[2][i] = a3[i];
           this->OP_cat[3][i] = a4[i];
           this->OP_cat[4][i] = a5[i];
           this->OP_cat[5][i] = a6[i];
           this->OP_cat[6][i] = a7[i];
           this->OP_cat[7][i] = a8[i];
           this->OP_cat[8][i] = a9[i];
           this->OP_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::V_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a3[] =  { 4, 4, 4, 3, 3, 3, 3, 3, 3, 3};
int a4[] =  { 4, 4, 3, 3, 3, 3, 2, 2, 2, 2};
int a5[] =  { 4, 4, 3, 3, 3, 2, 2, 1, 1, 2};
int a6[] =  { 3, 3, 3, 2, 2, 2, 2, 1, 1, 1};
int a7[] =  { 3, 3, 2, 2, 2, 1, 1, 1, 1, 1};
int a8[] =  { 3, 3, 2, 2, 1, 1, 1, 1, 1, 1};
int a9[] =  { 2, 2, 1, 1, 1, 1, 1, 1, 1, 1};
int a10[] = { 2, 1, 1, 1, 1, 1, 1, 1, 1, 1};

       for(int i = 0; i < 10; i++)
       {
           this->V_cat[0][i] = a1[i];
           this->V_cat[1][i] = a2[i];
           this->V_cat[2][i] = a3[i];
           this->V_cat[3][i] = a4[i];
           this->V_cat[4][i] = a5[i];
           this->V_cat[5][i] = a6[i];
           this->V_cat[6][i] = a7[i];
           this->V_cat[7][i] = a8[i];
           this->V_cat[8][i] = a9[i];
           this->V_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::SV_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a3[] =  { 4, 4, 4, 4, 4, 3, 3, 3, 3, 3};
int a4[] =  { 4, 4, 4, 3, 3, 3, 3, 2, 2, 2};
int a5[] =  { 4, 4, 3, 3, 3, 2, 2, 2, 1, 1};
int a6[] =  { 4, 4, 3, 3, 3, 2, 2, 2, 1, 1};
int a7[] =  { 4, 3, 3, 2, 2, 2, 2, 1, 1, 1};
int a8[] =  { 4, 3, 2, 2, 2, 1, 1, 1, 1, 1};
int a9[] =  { 4, 3, 2, 1, 1, 1, 1, 1, 1, 1};
int a10[] = { 2, 3, 2, 1, 1, 1, 1, 1, 1, 1};

       for(int i = 0; i < 10; i++)
       {
           this->SV_cat[0][i] = a1[i];
           this->SV_cat[1][i] = a2[i];
           this->SV_cat[2][i] = a3[i];
           this->SV_cat[3][i] = a4[i];
           this->SV_cat[4][i] = a5[i];
           this->SV_cat[5][i] = a6[i];
           this->SV_cat[6][i] = a7[i];
           this->SV_cat[7][i] = a8[i];
           this->SV_cat[8][i] = a9[i];
           this->SV_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::SN_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a3[] =  { 4, 4, 4, 4, 4, 3, 3, 3, 3, 3};
int a4[] =  { 4, 4, 4, 3, 3, 3, 3, 2, 2, 2};
int a5[] =  { 4, 4, 3, 3, 3, 2, 2, 2, 1, 1};
int a6[] =  { 4, 4, 3, 3, 3, 2, 2, 2, 1, 1};
int a7[] =  { 4, 3, 3, 2, 2, 2, 2, 1, 1, 1};
int a8[] =  { 4, 3, 2, 2, 2, 1, 1, 1, 1, 1};
int a9[] =  { 4, 3, 2, 1, 1, 1, 1, 1, 1, 1};
int a10[] = { 3, 3, 2, 1, 1, 1, 1, 1, 1, 1};

       for(int i = 0; i < 10; i++)
       {
           this->SN_cat[0][i] = a1[i];
           this->SN_cat[1][i] = a2[i];
           this->SN_cat[2][i] = a3[i];
           this->SN_cat[3][i] = a4[i];
           this->SN_cat[4][i] = a5[i];
           this->SN_cat[5][i] = a6[i];
           this->SN_cat[6][i] = a7[i];
           this->SN_cat[7][i] = a8[i];
           this->SN_cat[8][i] = a9[i];
           this->SN_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::T_cat_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a3[] =  { 4, 4, 4, 4, 4, 3, 3, 3, 3, 3};
int a4[] =  { 4, 4, 4, 3, 3, 3, 3, 3, 3, 2};
int a5[] =  { 4, 4, 3, 3, 3, 3, 2, 2, 2, 1};
int a6[] =  { 4, 3, 3, 3, 2, 2, 2, 2, 1, 1};
int a7[] =  { 4, 3, 3, 2, 2, 2, 2, 1, 1, 1};
int a8[] =  { 4, 3, 2, 2, 2, 1, 1, 1, 1, 1};
int a9[] =  { 4, 3, 2, 1, 1, 1, 1, 1, 1, 1};
int a10[] = { 3, 2, 1, 1, 1, 1, 1, 1, 1, 1};

       for(int i = 0; i < 10; i++)
       {
           this->T_cat[0][i] = a1[i];
           this->T_cat[1][i] = a2[i];
           this->T_cat[2][i] = a3[i];
           this->T_cat[3][i] = a4[i];
           this->T_cat[4][i] = a5[i];
           this->T_cat[5][i] = a6[i];
           this->T_cat[6][i] = a7[i];
           this->T_cat[7][i] = a8[i];
           this->T_cat[8][i] = a9[i];
           this->T_cat[9][i] = a10[i];

       }

}
//---------------------------------------------------------------------------
void Tdm::VOUPO_init()
{
//            1  2  3  4  5  6  7  8  9  10
int a1[] =  { 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};
int a2[] =  { 4, 4, 4, 4, 4, 4, 3, 3, 3, 3};
int a3[] =  { 4, 4, 4, 4, 4, 3, 3, 3, 3, 3};
int a4[] =  { 4, 4, 4, 4, 4, 3, 3, 3, 3, 2};
int a5[] =  { 4, 4, 4, 4, 3, 3, 3, 2, 2, 1};
int a6[] =  { 4, 4, 4, 3, 3, 3, 3, 2, 2, 1};
int a7[] =  { 4, 4, 4, 3, 3, 3, 3, 2, 2, 1};
int a8[] =  { 4, 4, 4, 3, 3, 3, 3, 2, 2, 1};
int a9[] =  { 4, 4, 4, 3, 3, 3, 3, 2, 2, 1};
int a10[] = { 4, 4, 4, 3, 3, 3, 3, 2, 2, 1};

       for(int i = 0; i < 10; i++)
       {
           this->VOUPO[0][i] = a1[i];
           this->VOUPO[1][i] = a2[i];
           this->VOUPO[2][i] = a3[i];
           this->VOUPO[3][i] = a4[i];
           this->VOUPO[4][i] = a5[i];
           this->VOUPO[5][i] = a6[i];
           this->VOUPO[6][i] = a7[i];
           this->VOUPO[7][i] = a8[i];
           this->VOUPO[8][i] = a9[i];
           this->VOUPO[9][i] = a10[i];

       }

}
void __fastcall Tdm::f_make_rep()
{
    int param[32];

    this->f_calc_stan();

    param[0] = this->s_test_points;
    param[1] = this->s_test_stan;

    param[2] = this->kot_points;
    param[3] = this->kot_stan;

    param[4] = this->OPS_points;
    param[5] = this->OPS_stan;

    param[6] = this->NPU_points;
    param[7] = this->NPU_stan;

    param[8] = this->N_points;
    param[9] = this->N_stan;

    param[10] = this->K_points;
    param[11] = this->K_stan;

    param[12] = this->OP_points;
    param[13] = this->OP_stan;

    param[14] = this->SV_points;
    param[15] = this->SV_stan;

    param[16] = this->V_points;
    param[17] = this->V_stan;

    param[18] = this->SN_points;
    param[19] = this->SN_stan;

    param[20] = this->T_points;
    param[21] = this->T_stan;

    param[22] = this->nn_cat_points;
    param[23] = this->NN_cat_points;

    param[24] = this->VOUPO_points;
    param[25] = this->K_cat_points;
    param[26] = this->OP_cat_points;
    param[27] = this->SV_cat_points;
    param[28] = this->V_cat_points;
    param[29] = this->SN_cat_points;
    param[30] = this->T_cat_points;

    param[31] = this->I_points;



     out_list.f_DrawAndPrint(param, name, DateToStr(birthday));
     HENHMETAFILE    hemf = GetEnhMetaFile("output.emf");
     RECT            rc;

/***MY***
     if(print->Execute())
     {
         Printer()->BeginDoc();
        //Determine logical pixel and output
		rc.left = 200;
		rc.top = 0;
		rc.right  = (LONG)GetDeviceCaps(Printer()->Handle, HORZRES);
		rc.bottom = (LONG)GetDeviceCaps(Printer()->Handle, VERTRES);
		PlayEnhMetaFile(Printer()->Handle, hemf, &rc);
                Printer()->EndDoc();
     }
     DeleteEnhMetaFile(hemf);


     AnsiString f1 = GetCurrentDir() + "\\output.emf";
     DeleteFile(f1);
***END MY***/
     AnsiString f1 = GetCurrentDir() + "\\output.emf";
     AnsiString f2 = GetCurrentDir() + "\\Results" + "\\" + name + ".emf";
     DeleteEnhMetaFile(hemf);
     RenameFile(f1, f2);
}

void Tdm::f_make_prognozrep()
{
     int   param[] = { i_points, yes_points, no_points, sum, score, group};
     out_list.print_prognoz(blank_out, param, name, DateToStr(Date()));

     HENHMETAFILE    hemf = GetEnhMetaFile("output_p.emf");
     RECT            rc;

/***MY***
     if(print->Execute())
     {
         Printer()->BeginDoc();
        //Determine logical pixel and output
		rc.left = 200;
		rc.top = 400;
		rc.right  = (LONG)GetDeviceCaps(Printer()->Handle, HORZRES);
		rc.bottom = (LONG)GetDeviceCaps(Printer()->Handle, VERTRES);
        rc.bottom /= 1.17;
        rc.right /= 1.05;
		PlayEnhMetaFile(Printer()->Handle, hemf, &rc);
                Printer()->EndDoc();
     }
     DeleteEnhMetaFile(hemf);

     AnsiString f1 = GetCurrentDir() + "\\output_p.emf";
     DeleteFile(f1);
***END MY***/
     AnsiString f1 = GetCurrentDir() + "\\output_p.emf";
     AnsiString f2 = GetCurrentDir() + "\\Results\\Prognoz" + "\\" + name + ".emf";
     DeleteEnhMetaFile(hemf);
     RenameFile(f1, f2);

}
void __fastcall Tdm::f_init()
{
        //here we will store test data and results
        name = "";
        unsigned short y = 1980, m = 03, d = 10;
        DecodeDate(birthday,  y, m, d);
        

        s_test_points = 0;
        INT s_test_stan = 0;

        INT kot_points = 0;
        INT kot_stan = 0;


        INT OPS_points = 0; // S points + Kot poINTs
        INT OPS_stan = 0;

        INT N_points = 0;
        INT N_stan = 0;

        INT I_points = 0;  // not in report

        INT V_points = 0;
        INT V_stan = 0;

        INT OP_points = 0;
        INT OP_stan = 0;

        INT NPU_points = 0;
        INT NPU_stan = 0;

        INT K_points = 0;
        INT K_stan = 0;

        INT SV_points = 0;
        INT SV_stan = 0;

        INT T_points = 0;
        INT T_stan = 0;

        INT SN_points = 0;
        INT SN_stan = 0;
        //INT _total;

        //also - categories points
        INT nn_cat_points = 0;
        INT NN_cat_points = 0;
        INT K_cat_points = 0;
        INT OP_cat_points = 0;
        INT V_cat_points = 0;
        INT SV_cat_points = 0;
        INT SN_cat_points = 0;
        INT T_cat_points = 0;
        INT VOUPO_points = 0;

        s_test_pass = false;
        kot_pass = false;
        vpp_pass = false;
        prog_pass = false;

        ////////////////////////////////////////////////////////
        //prognoz results
        i_points = 0;
        yes_points = 0;
        no_points = 0;
        sum = 0;
        score = 0;
        group = 0;

        nn_cat_init();
        NN_cat_init();
        K_cat_init();
        OP_cat_init();
        V_cat_init();
        SV_cat_init();
        SN_cat_init();
        T_cat_init();
        VOUPO_init();


       
        AnsiString f1 = GetCurrentDir() + "\\output.emf";
        DeleteFile(f1);
        f1 = GetCurrentDir() + "\\output_p.emf";
        DeleteFile(f1);
}




