//---------------------------------------------------------------------------
#ifndef f_dmH
#define f_dmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include "c_out_list.h"
#include <ExtCtrls.hpp>

#define INT int
//---------------------------------------------------------------------------
class Tdm : public TDataModule
{
__published:	// IDE-managed Components
    TOpenDialog *open;
    TPrintDialog *print;
private:	// User declarations
        void _fastcall f_calc_stan();
public:
        //here we will store test data and results
        AnsiString name;
        TDate birthday;


        INT s_test_points;
        INT s_test_stan;

        INT kot_points;
        INT kot_stan;


        INT OPS_points; // S points + Kot poINTs
        INT OPS_stan;

        INT N_points;
        INT N_stan;

        INT I_points;  // not in report

        INT V_points;
        INT V_stan;

        INT OP_points;
        INT OP_stan;

        INT NPU_points;
        INT NPU_stan;

        INT K_points;
        INT K_stan;

        INT SV_points;
        INT SV_stan;

        INT T_points;
        INT T_stan;

        INT SN_points;
        INT SN_stan;
        //INT _total;

        //also - categories points
        INT nn_cat_points;
        INT NN_cat_points;
        INT K_cat_points;
        INT OP_cat_points;
        INT V_cat_points;
        INT SV_cat_points;
        INT SN_cat_points;
        INT T_cat_points;
        INT VOUPO_points;

        c_out_list out_list;

        //Categories
        INT nn_cat[10][10];
        INT NN_cat[10][10];

        INT K_cat[10][10];
        INT OP_cat[10][10];
        INT V_cat[10][10];
        INT SV_cat[10][10];
        INT SN_cat[10][10];
        INT T_cat[10][10];
        INT VOUPO[10][10];

        bool s_test_pass;
        bool kot_pass;
        bool vpp_pass;
        bool prog_pass;

        ////////////////////////////////////////////////////////
        //prognoz results
        int              i_points;
        int              yes_points;
        int              no_points;
        int              sum;
        int              score;
        int              group;

        bool*            blank_out;
        void             f_make_prognozrep();

        //functions for initializing categories
        void        nn_cat_init();
        void        NN_cat_init();
        void        K_cat_init();
        void        OP_cat_init();
        void        V_cat_init();
        void        SV_cat_init();
        void        SN_cat_init();
        void        T_cat_init();
        void        VOUPO_init();


public:		// User declarations
        void __fastcall f_make_rep();
        void __fastcall f_init();


    __fastcall Tdm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE Tdm *dm;
//---------------------------------------------------------------------------
#endif
