//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "s_test.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tf_stest *f_stest;
//---------------------------------------------------------------------------
__fastcall Tf_stest::Tf_stest(TComponent* Owner)
    : TForm(Owner)
{
    f_init();

}
//---------------------------------------------------------------------------
void __fastcall Tf_stest::f_refresh()
{
     //forming string for file
     AnsiString file_name;
     if(current_step < 9)
          file_name = "00" + IntToStr(this->current_step + 1) + ".bmp";
     else
     if(current_step < 99 && current_step >= 9)
          file_name = "0" + IntToStr(this->current_step + 1) + ".bmp";
     else
     if(current_step >= 99 && current_step <= 149)
          file_name = IntToStr(this->current_step + 1) + ".bmp";
     else
     if(current_step > 149) {this->f_calc_results(); return;}

     file_name = this->work_dir + "\\images" + "\\" + file_name;

     //loading new picture and refreshing
     pict->Picture->LoadFromFile(file_name);

}
//---------------------------------------------------------------------------
void __fastcall Tf_stest::FormKeyPress(TObject *Sender, char &Key)
{
      // depending on steps
      switch(Key)
      {
          case '1':
              this->s_test_user[this->current_step] = 1;
          break;
          case '2':
              this->s_test_user[this->current_step] = 2;
          break;
          case '3':
              this->s_test_user[this->current_step] = 3;
          break;
          case '4':
              this->s_test_user[this->current_step] = 4;
          break;
          default:
              return;
      }

      //increasing step and changing picture
      this->current_step++;
      this->f_refresh();
}
//---------------------------------------------------------------------------
void __fastcall Tf_stest::f_calc_results()
{
    //Calculate totally points
    for( int i = 0; i < this->current_step; i++)
        if(this->s_test_keys[i] == this->s_test_user[i])
                this->totally_points++;

    dm->s_test_points = this->totally_points;
    this->current_step = 0;

    can_close = true;

    this->Close();
    return;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
bool __fastcall Tf_stest::f_check_env()
{
    //Calculate totally points
    AnsiString file_name;
    for( int i = 1; i <= 150; i++)
    {
       if(i < 10)
          file_name = "00" + IntToStr(i) + ".bmp";
       else
       if(i < 100 && i >= 10)
          file_name = "0" + IntToStr(i) + ".bmp";
       else
       if(i >= 100 )
          file_name = IntToStr(i) + ".bmp";

     file_name = this->work_dir + "\\images" + "\\" + file_name;

     if(!FileExists(file_name)) return false;

    }

    return true;               //if we here - always true
}
//---------------------------------------------------------------------------
void __fastcall Tf_stest::f_init()
{

      //  
      this->finish_time = Time() + EncodeTime(0,5, 00,0);
      AnsiString a = TimeToStr(finish_time);
      this->current_step = 0;
      this->totally_points = 0;

      work_dir = ExtractFilePath(ParamStr(0));

      // 
      for(int i = 0; i < 150; i++)
      {
          this->s_test_user[i] = 0;
      }

      //filling keys array
      s_test_keys[0] = 1;
      s_test_keys[1] = 4;
      s_test_keys[2] = 3;
      s_test_keys[3] = 4;
      s_test_keys[4] = 2;
      s_test_keys[5] = 1;
      s_test_keys[6] = 4;
      s_test_keys[7] = 1;
      s_test_keys[8] = 3;
      s_test_keys[9] = 4;
      s_test_keys[10] = 1;
      s_test_keys[11] = 2;
      s_test_keys[12] = 3;
      s_test_keys[13] = 1;
      s_test_keys[14] = 2;

      //2
      s_test_keys[15] = 4;
      s_test_keys[16] = 1;
      s_test_keys[17] = 3;
      s_test_keys[18] = 2;
      s_test_keys[19] = 1;
      s_test_keys[20] = 2;
      s_test_keys[21] = 3;
      s_test_keys[22] = 1;
      s_test_keys[23] = 3;
      s_test_keys[24] = 4;
      s_test_keys[25] = 2;
      s_test_keys[26] = 3;
      s_test_keys[27] = 1;
      s_test_keys[28] = 3;
      s_test_keys[29] = 4;

      //3
      s_test_keys[30] = 3;
      s_test_keys[31] = 2;
      s_test_keys[32] = 1;
      s_test_keys[33] = 4;
      s_test_keys[34] = 2;
      s_test_keys[35] = 3;
      s_test_keys[36] = 4;
      s_test_keys[37] = 2;
      s_test_keys[38] = 4;
      s_test_keys[39] = 3;
      s_test_keys[40] = 1;
      s_test_keys[41] = 3;
      s_test_keys[42] = 4;
      s_test_keys[43] = 2;
      s_test_keys[44] = 2;

      //4
      s_test_keys[45] = 1;
      s_test_keys[46] = 3;
      s_test_keys[47] = 4;
      s_test_keys[48] = 4;
      s_test_keys[49] = 3;
      s_test_keys[50] = 4;
      s_test_keys[51] = 1;
      s_test_keys[52] = 2;
      s_test_keys[53] = 3;
      s_test_keys[54] = 1;
      s_test_keys[55] = 4;
      s_test_keys[56] = 1;
      s_test_keys[57] = 3;
      s_test_keys[58] = 2;
      s_test_keys[59] = 1;

      //5
      s_test_keys[60] = 2;
      s_test_keys[61] = 3;
      s_test_keys[62] = 1;
      s_test_keys[63] = 3;
      s_test_keys[64] = 2;
      s_test_keys[65] = 4;
      s_test_keys[66] = 4;
      s_test_keys[67] = 1;
      s_test_keys[68] = 3;
      s_test_keys[69] = 4;
      s_test_keys[70] = 2;
      s_test_keys[71] = 1;
      s_test_keys[72] = 2;
      s_test_keys[73] = 1;
      s_test_keys[74] = 4;

      //6
      s_test_keys[75] = TWO;
      s_test_keys[76] = THREE;
      s_test_keys[77] = TWO;
      s_test_keys[78] = FOUR;
      s_test_keys[79] = ONE;
      s_test_keys[80] = FOUR;
      s_test_keys[81] = TWO;
      s_test_keys[82] = ONE;
      s_test_keys[83] = FOUR;
      s_test_keys[84] = FOUR;
      s_test_keys[85] = ONE;
      s_test_keys[86] = TWO;
      s_test_keys[87] = THREE;
      s_test_keys[88] = THREE;
      s_test_keys[89] = ONE;

      //7
      s_test_keys[90] = THREE;
      s_test_keys[91] = TWO;
      s_test_keys[92] = FOUR;
      s_test_keys[93] = FOUR;
      s_test_keys[94] = TWO;
      s_test_keys[95] = THREE;
      s_test_keys[96] = FOUR;
      s_test_keys[97] = THREE;
      s_test_keys[98] = FOUR;
      s_test_keys[99] = ONE;
      s_test_keys[100] = TWO;
      s_test_keys[101] = ONE;
      s_test_keys[102] = THREE;
      s_test_keys[103] = TWO;
      s_test_keys[104] = ONE;

      //8
      s_test_keys[105] = THREE;
      s_test_keys[106] = TWO;
      s_test_keys[107] = FOUR;
      s_test_keys[108] = ONE;
      s_test_keys[109] = TWO;
      s_test_keys[110] = THREE;
      s_test_keys[111] = ONE;
      s_test_keys[112] = THREE;
      s_test_keys[113] = FOUR;
      s_test_keys[114] = TWO;
      s_test_keys[115] = FOUR;
      s_test_keys[116] = TWO;
      s_test_keys[117] = THREE;
      s_test_keys[118] = FOUR;
      s_test_keys[119] = ONE;

      //9
      s_test_keys[120] = ONE;
      s_test_keys[121] = TWO;
      s_test_keys[122] = THREE;
      s_test_keys[123] = ONE;
      s_test_keys[124] = THREE;
      s_test_keys[125] = FOUR;
      s_test_keys[126] = TWO;
      s_test_keys[127] = FOUR;
      s_test_keys[128] = 2;
      s_test_keys[129] = 4;
      s_test_keys[130] = THREE;
      s_test_keys[131] = 1;
      s_test_keys[132] = FOUR;
      s_test_keys[133] = THREE;
      s_test_keys[134] = ONE;

      //10
      s_test_keys[135] = ONE;
      s_test_keys[136] = TWO;
      s_test_keys[137] = FOUR;
      s_test_keys[138] = ONE;
      s_test_keys[139] = TWO;
      s_test_keys[140] = TWO;
      s_test_keys[141] = THREE;
      s_test_keys[142] = FOUR;
      s_test_keys[143] = THREE;
      s_test_keys[144] = ONE;
      s_test_keys[145] = FOUR;
      s_test_keys[146] = THREE;
      s_test_keys[147] = FOUR;
      s_test_keys[148] = THREE;
      s_test_keys[149] = ONE;



     can_close = false;

     this->f_refresh();


}
void __fastcall Tf_stest::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
      if(Shift.Contains(ssAlt) && Key == VK_F4)
      {
          f_main_form->output->Lines->Add("[S_test]   t...");
      }
}
//---------------------------------------------------------------------------

void __fastcall Tf_stest::Timer1Timer(TObject *Sender)
{

     if( (finish_time - Time()) < EncodeTime(0,0,0,0) || this->current_step == 150)
     {
            
            this->f_calc_results();


            return;
     }
     else
     this->Caption = "[S-]. " + IntToStr(this->current_step + 1) + "  150.  " + TimeToStr(finish_time - Time());
}
//---------------------------------------------------------------------------

void __fastcall Tf_stest::FormShow(TObject *Sender)
{
     f_init();
}
//---------------------------------------------------------------------------

void __fastcall Tf_stest::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if(can_close) CanClose = true;
    else
    CanClose = false;
}
//---------------------------------------------------------------------------


void __fastcall Tf_stest::pictClick(TObject *Sender)
{
f_calc_results();
}
//---------------------------------------------------------------------------

