//---------------------------------------------------------------------------
#ifndef vppH
#define vppH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class Tf_vpp : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TPanel *Panel2;
        TLabel *q1;
        TLabel *q2;
        TLabel *q3;
        TLabel *q4;
        TMemo *quest_show;
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);

        void __fastcall quest_showKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
        AnsiString quest[169];
        int current_step;
        bool can_close;

        //and keys

        bool vpp_user[168][4];

        int N_keys[28];
        int N_points;

        int I_keys[7];
        int I_points;

        int V_keys[14];
        int V_points;

        int OP_keys[14];
        int OP_points;

        int NPU_keys[56];
        int NPU_points;

        int K_keys[21];
        int K_points;

        int SV_keys[14];
        int SV_points;

        int T_keys[28];
        int T_points;

        int SN_keys[14];
        int SN_points;

        void __fastcall f_refresh();
        void __fastcall f_calculate();
        void __fastcall f_init();


public:		// User declarations
        __fastcall Tf_vpp(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE Tf_vpp *f_vpp;
//---------------------------------------------------------------------------
#endif
